diff --git a/CMakeLists.txt b/CMakeLists.txt
index 1d47a9e724..f06347e277 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -26,6 +26,7 @@ set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS )
 set(JERRY_CMDLINE         ON  CACHE BOOL "Build jerry command line tool?")
 set(JERRY_CMDLINE_MINIMAL OFF CACHE BOOL "Build jerry minimal command line tool?")
 set(JERRY_PORT_DEFAULT    ON  CACHE BOOL "Build default jerry port implementation?")
+set(JERRY_EXT             ON  CACHE BOOL "Build jerry-ext?")
 set(JERRY_LIBC            ON  CACHE BOOL "Build and use jerry-libc?")
 set(JERRY_LIBM            ON  CACHE BOOL "Build and use jerry-libm?")
 set(UNITTESTS             OFF CACHE BOOL "Build unit tests?")
@@ -94,6 +95,7 @@ message(STATUS "ENABLE_STRIP              " ${ENABLE_STRIP} ${ENABLE_STRIP_MESSA
 message(STATUS "JERRY_CMDLINE             " ${JERRY_CMDLINE})
 message(STATUS "JERRY_CMDLINE_MINIMAL     " ${JERRY_CMDLINE_MINIMAL})
 message(STATUS "JERRY_PORT_DEFAULT        " ${JERRY_PORT_DEFAULT} ${JERRY_PORT_DEFAULT_MESSAGE})
+message(STATUS "JERRY_EXT                 " ${JERRY_EXT} ${JERRY_EXT_MESSAGE})
 message(STATUS "JERRY_LIBC                " ${JERRY_LIBC} ${JERRY_LIBC_MESSAGE})
 message(STATUS "JERRY_LIBM                " ${JERRY_LIBM} ${JERRY_LIBM_MESSAGE})
 message(STATUS "UNITTESTS                 " ${UNITTESTS})
@@ -238,6 +240,11 @@ if(JERRY_PORT_DEFAULT)
   add_subdirectory(jerry-port/default)
 endif()
 
+# Jerry's extension tools
+if(JERRY_EXT)
+  add_subdirectory(jerry-ext)
+endif()
+
 # Jerry command line tool
 if(JERRY_CMDLINE OR JERRY_CMDLINE_MINIMAL)
   add_subdirectory(jerry-main)
@@ -249,4 +256,7 @@ if(UNITTESTS)
   if(JERRY_LIBM)
     add_subdirectory(tests/unit-libm)
   endif()
+  if(JERRY_EXT)
+    add_subdirectory(tests/unit-ext)
+  endif()
 endif()
diff --git a/jerry-ext/CMakeLists.txt b/jerry-ext/CMakeLists.txt
new file mode 100644
index 0000000000..eefcfbfe6c
--- /dev/null
+++ b/jerry-ext/CMakeLists.txt
@@ -0,0 +1,32 @@
+# Copyright JS Foundation and other contributors, http://js.foundation
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+cmake_minimum_required (VERSION 2.8.12)
+set(JERRY_EXT_NAME jerry-ext)
+project (${JERRY_EXT_NAME} C)
+
+# Include directories
+set(INCLUDE_EXT "${CMAKE_CURRENT_SOURCE_DIR}/include")
+
+# Source directories
+file(GLOB SOURCE_EXT args/*.c)
+
+add_library(${JERRY_EXT_NAME} STATIC ${SOURCE_EXT})
+
+target_include_directories(${JERRY_EXT_NAME} PUBLIC ${INCLUDE_EXT})
+
+target_link_libraries(${JERRY_EXT_NAME} jerry-core)
+
+install(TARGETS ${JERRY_EXT_NAME} DESTINATION lib)
+install(DIRECTORY ${INCLUDE_EXT}/ DESTINATION include)
diff --git a/jerry-ext/args/arg-iterator-helper.c b/jerry-ext/args/arg-iterator-helper.c
new file mode 100644
index 0000000000..0b9cf99b6d
--- /dev/null
+++ b/jerry-ext/args/arg-iterator-helper.c
@@ -0,0 +1,66 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include "jerryscript-ext/args.h"
+#include "jerryscript.h"
+
+/**
+ * Pop the current JS argument.
+ *
+ * @return the current JS argument.
+ */
+jerry_value_t
+jerryx_arg_iterator_pop (jerryx_arg_iterator_t *iterator_p) /**< points to the argument iterator */
+{
+  if (iterator_p->js_arg_index >= iterator_p->js_arg_cnt)
+  {
+    return jerry_create_undefined ();
+  }
+
+  jerry_value_t ret = *iterator_p->js_arg_p;
+  iterator_p->js_arg_index++;
+  iterator_p->js_arg_p++;
+
+  return ret;
+} /* jerryx_arg_iterator_pop */
+
+/**
+ * Get the peek value of the iterator.
+ *
+ * Note: Unlike jerryx_arg_iterator_pop, it will not change the iterator_p.
+ *
+ * @return the current JS argument.
+ */
+jerry_value_t
+jerryx_arg_iterator_peek (jerryx_arg_iterator_t *iterator_p) /**< points to the argument iterator */
+{
+  if (iterator_p->js_arg_index >= iterator_p->js_arg_cnt)
+  {
+    return jerry_create_undefined ();
+  }
+
+  return *iterator_p->js_arg_p;
+} /* jerryx_arg_iterator_peek */
+
+/**
+ * Get the pointer to the current native argument.
+ *
+ * @return a pointer
+ */
+inline void *
+jerryx_arg_iterator_get_dest (jerryx_arg_iterator_t *iterator_p) /**< points to the argument iterator */
+{
+  return iterator_p->c_arg_p->dest;
+} /* jerryx_arg_iterator_get_dest */
diff --git a/jerry-ext/args/arg-transform-functions.c b/jerry-ext/args/arg-transform-functions.c
new file mode 100644
index 0000000000..a5bba9fef3
--- /dev/null
+++ b/jerry-ext/args/arg-transform-functions.c
@@ -0,0 +1,294 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include "jerryscript-ext/args.h"
+#include "jerryscript.h"
+
+/**
+ * The common function to deal with optional arguments.
+ *
+ * @return jerry value
+ */
+static jerry_value_t
+jerryx_arg_transform_optional (jerryx_arg_iterator_t *iterator_p, /**< points to the arg iterator */
+                               jerryx_arg_transform_func_t func) /**< the core transform function */
+{
+  jerry_value_t peeked_js_arg = jerryx_arg_iterator_peek (iterator_p);
+
+  if (jerry_value_is_undefined (peeked_js_arg))
+  {
+    jerryx_arg_iterator_pop (iterator_p);
+    return jerry_create_undefined ();
+  }
+
+  return func (iterator_p);
+} /* jerryx_arg_transform_optional */
+
+/**
+ * Tranform a JS argument to a double. Type coercion is not allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_number_strict_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  if (!jerry_value_is_number (js_arg))
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It is not a number.");
+  }
+
+  double *dest = jerryx_arg_iterator_get_dest (iterator_p);
+  *dest = jerry_get_number_value (js_arg);
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_number_strict_impl */
+
+/**
+ * Tranform a JS argument to a double. Type coercion is allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_number_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  jerry_value_t to_number = jerry_value_to_number (js_arg);
+
+  if (jerry_value_has_error_flag (to_number))
+  {
+    jerry_release_value (to_number);
+
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It can not be converted to a number.");
+  }
+
+  double *dest = jerryx_arg_iterator_get_dest (iterator_p);
+  *dest = jerry_get_number_value (to_number);
+  jerry_release_value (to_number);
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_number_impl */
+
+/**
+ * Tranform a JS argument to a boolean. Type coercion is not allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_boolean_strict_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  if (!jerry_value_is_boolean (js_arg))
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It is not a boolean.");
+  }
+
+  bool *dest = jerryx_arg_iterator_get_dest (iterator_p);
+  *dest = jerry_get_boolean_value (js_arg);
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_boolean_strict_impl */
+
+/**
+ * Tranform a JS argument to a boolean. Type coercion is allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_boolean_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  bool to_boolean = jerry_value_to_boolean (js_arg);
+
+  bool *dest = jerryx_arg_iterator_get_dest (iterator_p);
+  *dest = to_boolean;
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_boolean_impl */
+
+/**
+ * The common routine for string tranformor.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_string_common_routine (jerryx_arg_iterator_t *iterator_p, /**< points to the arg iterator */
+                                  jerry_value_t js_arg) /**< the js argument */
+{
+  const jerry_size_t dest_len = (const jerry_size_t) iterator_p->c_arg_p->extra_info;
+  char *dest = jerryx_arg_iterator_get_dest (iterator_p);
+
+  const jerry_size_t size = jerry_string_to_char_buffer (js_arg,
+                                                         (jerry_char_t *) dest,
+                                                         dest_len);
+
+  if (size == 0)
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "The size of the buffer is not large enough.");
+  }
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_string_common_routine */
+
+/**
+ * Tranform a JS argument to a char array. Type coercion is not allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_string_strict_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  if (!jerry_value_is_string (js_arg))
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It is not a string.");
+  }
+
+  return jerryx_arg_string_common_routine (iterator_p, js_arg);
+} /* jerryx_arg_transform_string_strict_impl */
+
+/**
+ * Tranform a JS argument to a char array. Type coercion is allowed.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_string_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  jerry_value_t to_string = jerry_value_to_string (js_arg);
+
+  if (jerry_value_has_error_flag (to_string))
+  {
+    jerry_release_value (to_string);
+
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It can not be converted to a string.");
+  }
+
+  jerry_value_t ret = jerryx_arg_string_common_routine (iterator_p, to_string);
+  jerry_release_value (to_string);
+
+  return ret;
+} /* jerryx_arg_transform_string_impl */
+
+/**
+ * Check whether the JS argument is jerry function, if so, assign to the native argument.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_function_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  if (!jerry_value_is_function (js_arg))
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It is not a function.");
+  }
+
+  jerry_value_t *func_p = jerryx_arg_iterator_get_dest (iterator_p);
+  *func_p = jerry_acquire_value (js_arg);
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_function_impl */
+
+/**
+ * Check whether the native pointer has the expected type info.
+ * If so, assign it to the native argument.
+ *
+ * @return undefined - if succeed
+ *         jerry error value - otherwise
+ */
+static jerry_value_t
+jerryx_arg_transform_native_pointer_impl (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+
+  if (!jerry_value_is_object (js_arg))
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It is not a object.");
+  }
+
+  const jerry_object_native_info_t *expected_info_p;
+  const jerry_object_native_info_t *out_info_p;
+  expected_info_p = (const jerry_object_native_info_t *) iterator_p->c_arg_p->extra_info;
+  void **ptr_p = (void **) jerryx_arg_iterator_get_dest (iterator_p);
+  bool is_ok = jerry_get_object_native_pointer (js_arg, ptr_p, &out_info_p);
+
+  if (!is_ok || out_info_p != expected_info_p)
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "The object has no native pointer or type does not match.");
+  }
+
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_native_pointer_impl */
+
+/**
+ * Define the two tranformer for certain type.
+ * One for required argument and the other is for optional argument.
+ */
+#define JERRYX_ARG_TRANSFORM_DEF(type) jerry_value_t \
+ jerryx_arg_transform_ ## type (jerryx_arg_iterator_t *iterator_p) \
+{ \
+ return jerryx_arg_transform_ ## type ## _impl (iterator_p); \
+} \
+jerry_value_t jerryx_arg_transform_ ## type ## _optional (jerryx_arg_iterator_t *iterator_p) \
+{ \
+ return jerryx_arg_transform_optional(iterator_p, jerryx_arg_transform_ ## type ## _impl); \
+} \
+
+JERRYX_ARG_TRANSFORM_DEF (number)
+JERRYX_ARG_TRANSFORM_DEF (number_strict)
+JERRYX_ARG_TRANSFORM_DEF (boolean)
+JERRYX_ARG_TRANSFORM_DEF (boolean_strict)
+JERRYX_ARG_TRANSFORM_DEF (string)
+JERRYX_ARG_TRANSFORM_DEF (string_strict)
+JERRYX_ARG_TRANSFORM_DEF (function)
+JERRYX_ARG_TRANSFORM_DEF (native_pointer)
+
+/**
+ * Ignore the JS argument.
+ *
+ * @return undefined
+ */
+jerry_value_t
+jerryx_arg_transform_ignore (jerryx_arg_iterator_t *iterator_p) /**< points to the arg iterator */
+{
+  jerryx_arg_iterator_pop (iterator_p);
+  return jerry_create_undefined ();
+} /* jerryx_arg_transform_ignore */
diff --git a/jerry-ext/args/args.c b/jerry-ext/args/args.c
new file mode 100644
index 0000000000..7a086544fe
--- /dev/null
+++ b/jerry-ext/args/args.c
@@ -0,0 +1,97 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#include "jerryscript-ext/args.h"
+#include "jerryscript.h"
+
+/**
+ * Validate the JS arguments and assign them to the native arguments.
+ *
+ * @return jerry undefined: the validator passes,
+ *         jerry error: the validator fails.
+ */
+jerry_value_t
+jerryx_arg_transform_args (const jerry_value_t *js_arg_p, /**< points to the js argument */
+                           const jerry_length_t js_arg_cnt, /**< the count of the js arguments */
+                           const jerryx_arg_t *c_arg_p, /**< points to the jerryx_arg_t */
+                           const jerry_length_t c_arg_cnt) /**< the count of the native argument */
+{
+  jerry_value_t ret = jerry_create_undefined ();
+
+  if (c_arg_cnt == 0)
+  {
+    return ret;
+  }
+
+  jerryx_arg_iterator_t iterator =
+  {
+    .c_arg_p = c_arg_p,
+    .js_arg_p = js_arg_p,
+    .js_arg_cnt = js_arg_cnt,
+    .js_arg_index = 0
+  };
+
+  jerry_length_t c_arg_index = 0;
+
+
+  while (c_arg_index < c_arg_cnt)
+  {
+    iterator.c_arg_p = c_arg_p;
+
+    ret = iterator.c_arg_p->func (&iterator);
+
+    if (jerry_value_has_error_flag (ret))
+    {
+      break;
+    }
+
+    c_arg_index++;
+    c_arg_p++;
+  }
+
+  return ret;
+} /* jerryx_arg_transform_args */
+
+/**
+ * Validate the this value and the JS arguments,
+ * and assign them to the native arguments.
+ *
+ * @return jerry undefined: the validator passes,
+ *         jerry error: the validator fails.
+ */
+jerry_value_t
+jerryx_arg_transform_all (const jerry_value_t this_val, /**< the this_val for the external function */
+                          const jerry_value_t *js_arg_p, /**< points to the js argument */
+                          const jerry_length_t js_arg_cnt, /**< the count of the js arguments */
+                          const jerryx_arg_t *c_arg_p, /**< points to the jerryx_arg_t */
+                          const jerry_length_t c_arg_cnt) /**< the count of the native argument */
+{
+  if (c_arg_cnt == 0)
+  {
+    return jerry_create_undefined ();
+  }
+
+  jerry_value_t is_ok = jerryx_arg_transform_args (&this_val, 1, &c_arg_p[0], 1);
+
+  if (jerry_value_has_error_flag (is_ok))
+  {
+    jerry_release_value (is_ok);
+
+    return jerry_create_error (JERRY_ERROR_TYPE, (jerry_char_t *) "'this' validation failed");
+  }
+
+
+  return jerryx_arg_transform_args (js_arg_p, js_arg_cnt, &c_arg_p[1], c_arg_cnt - 1);
+} /* jerryx_arg_transform_all */
diff --git a/jerry-ext/include/jerryscript-ext/args.h b/jerry-ext/include/jerryscript-ext/args.h
new file mode 100644
index 0000000000..61100deb7c
--- /dev/null
+++ b/jerry-ext/include/jerryscript-ext/args.h
@@ -0,0 +1,115 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef JERRYX_ARGS_H
+#define JERRYX_ARGS_H
+
+#include <assert.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <stdint.h>
+#include "jerryscript.h"
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif /* __cplusplus */
+
+typedef struct jerryx_arg_t jerryx_arg_t;
+typedef struct jerryx_arg_iterator_t jerryx_arg_iterator_t;
+
+/**
+ * Signature of the transform funtion.
+ */
+typedef jerry_value_t (*jerryx_arg_transform_func_t) (jerryx_arg_iterator_t *iterator_p);
+
+/**
+ * The structure of the jerry argument in arg transform.
+ * Each native argument should have one corresponding jerryx_arg_t item.
+ */
+struct jerryx_arg_t
+{
+  jerryx_arg_transform_func_t func; /**< the transform function for the native argument */
+  void *dest; /**< point to the native argument */
+  uintptr_t extra_info; /**< extra infomation for arg transform */
+};
+
+/**
+ * The argument iteration used for transform funtions.
+ */
+struct jerryx_arg_iterator_t
+{
+  const jerryx_arg_t *c_arg_p; /**< points to the current jerryx_arg_t */
+  const jerry_value_t *js_arg_p; /**< points to the current js argument */
+  const jerry_length_t  js_arg_cnt; /**< the total count of the js arguments */
+  jerry_length_t  js_arg_index; /**< the current index of the js argument */
+};
+
+jerry_value_t jerryx_arg_transform_all (const jerry_value_t this_val,
+                                        const jerry_value_t *js_arg_p,
+                                        const jerry_length_t js_arg_cnt,
+                                        const jerryx_arg_t *c_arg_p,
+                                        const jerry_length_t c_arg_cnt);
+
+jerry_value_t jerryx_arg_transform_args (const jerry_value_t *js_arg_p,
+                                         const jerry_length_t js_arg_cnt,
+                                         const jerryx_arg_t *c_arg_p,
+                                         const jerry_length_t c_arg_cnt);
+
+/* Helper functions for jerryx_arg_iterator_t. */
+jerry_value_t jerryx_arg_iterator_pop (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_iterator_peek (jerryx_arg_iterator_t *iterator_p);
+void *jerryx_arg_iterator_get_dest (jerryx_arg_iterator_t *iterator_p);
+
+/**
+ * Indicates whether an argument can be coerced into the target type.
+ */
+typedef enum
+{
+  JERRYX_ARG_COERCE, /**< the transform inside will invoke toNumber, toBoolean or toString */
+  JERRYX_ARG_NO_COERCE /**< the type coercion is not allowed. */
+} jerryx_arg_coerce_t;
+
+/**
+ * Indicates whether an argument is optional or required.
+ */
+typedef enum
+{
+  JERRYX_ARG_OPTIONAL, /**< the argument is optional */
+  JERRYX_ARG_REQUIRED /**< the argument is required. */
+} jerryx_arg_optional_t;
+
+/* Inline functions for initializing jerryx_arg_t */
+static inline jerryx_arg_t
+jerryx_arg_number (double *dest, jerryx_arg_coerce_t conv_flag, jerryx_arg_optional_t opt_flag);
+static inline jerryx_arg_t
+jerryx_arg_boolean (bool *dest, jerryx_arg_coerce_t conv_flag, jerryx_arg_optional_t opt_flag);
+static inline jerryx_arg_t
+jerryx_arg_string (char *dest, uint32_t size, jerryx_arg_coerce_t conv_flag, jerryx_arg_optional_t opt_flag);
+static inline jerryx_arg_t
+jerryx_arg_function (jerry_value_t *dest, jerryx_arg_optional_t opt_flag);
+static inline jerryx_arg_t
+jerryx_arg_native_pointer (void **dest, const jerry_object_native_info_t *info_p, jerryx_arg_optional_t opt_flag);
+static inline jerryx_arg_t
+jerryx_arg_ignore (void);
+static inline jerryx_arg_t
+jerryx_arg_custom (void *dest, uintptr_t extra_info, jerryx_arg_transform_func_t func);
+
+#include "args.impl.h"
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+#endif /* !JERRYX_ARGS_H */
diff --git a/jerry-ext/include/jerryscript-ext/args.impl.h b/jerry-ext/include/jerryscript-ext/args.impl.h
new file mode 100644
index 0000000000..1eec6d33df
--- /dev/null
+++ b/jerry-ext/include/jerryscript-ext/args.impl.h
@@ -0,0 +1,256 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef JERRYX_ARGS_IMPL_H
+#define JERRYX_ARGS_IMPL_H
+
+/* transform functions for each type. */
+jerry_value_t jerryx_arg_transform_number_strict (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_number_strict_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_number_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_number (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_boolean_strict (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_boolean_strict_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_boolean_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_boolean (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_string_strict (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_string_strict_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_string_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_string (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_function (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_function_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_constructor (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_constructor_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_native_pointer (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_native_pointer_optional (jerryx_arg_iterator_t *iterator_p);
+jerry_value_t jerryx_arg_transform_ignore (jerryx_arg_iterator_t *iterator_p);
+
+/**
+ * Create a jerryx_arg_t instance for number argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_number (double *dest, /**< points to the native number */
+                   jerryx_arg_coerce_t coerce_flag, /**< whether the type coercion is allowed */
+                   jerryx_arg_optional_t opt_flag) /**< whether it is optional argument */
+{
+  jerryx_arg_transform_func_t func;
+
+  if (coerce_flag == JERRYX_ARG_NO_COERCE)
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_number_strict_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_number_strict;
+    }
+  }
+  else
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_number_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_number;
+    }
+  }
+
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = (void *) dest
+  };
+} /* jerryx_arg_number */
+
+/**
+ * Create a jerryx_arg_t instance for boolean argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_boolean (bool *dest, /**< points to the native bool */
+                    jerryx_arg_coerce_t coerce_flag, /**< whether the type coercion is allowed */
+                    jerryx_arg_optional_t opt_flag) /**< whether it is optional argument */
+{
+  jerryx_arg_transform_func_t func;
+
+  if (coerce_flag == JERRYX_ARG_NO_COERCE)
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_boolean_strict_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_boolean_strict;
+    }
+  }
+  else
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_boolean_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_boolean;
+    }
+  }
+
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = (void *) dest
+  };
+} /* jerryx_arg_boolean */
+
+/**
+ * Create a jerryx_arg_t instance for string argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_string (char *dest, /**< points to the native char array */
+                   uint32_t size, /**< the size of native char array */
+                   jerryx_arg_coerce_t coerce_flag, /**< whether the type coercion is allowed */
+                   jerryx_arg_optional_t opt_flag) /**< whether it is optional argument */
+{
+  jerryx_arg_transform_func_t func;
+
+  if (coerce_flag == JERRYX_ARG_NO_COERCE)
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_string_strict_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_string_strict;
+    }
+  }
+  else
+  {
+    if (opt_flag == JERRYX_ARG_OPTIONAL)
+    {
+      func = jerryx_arg_transform_string_optional;
+    }
+    else
+    {
+      func = jerryx_arg_transform_string;
+    }
+  }
+
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = (void *) dest,
+    .extra_info = (uintptr_t) size
+  };
+} /* jerryx_arg_string */
+
+/**
+ * Create a jerryx_arg_t instance for function argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_function (jerry_value_t *dest, /**< points to the js function value */
+                     jerryx_arg_optional_t opt_flag) /**< whether it is optional argument */
+{
+  jerryx_arg_transform_func_t func;
+
+  if (opt_flag == JERRYX_ARG_OPTIONAL)
+  {
+    func = jerryx_arg_transform_function_optional;
+  }
+  else
+  {
+    func = jerryx_arg_transform_function;
+  }
+
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = (void *) dest
+  };
+} /* jerryx_arg_function */
+
+/**
+ * Create a jerryx_arg_t instance for native pointer argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_native_pointer (void **dest, /**< points to the native pointer */
+                           const jerry_object_native_info_t *info_p, /**< expected the type info */
+                           jerryx_arg_optional_t opt_flag) /**< whether it is optional argument */
+{
+  jerryx_arg_transform_func_t func;
+
+  if (opt_flag == JERRYX_ARG_OPTIONAL)
+  {
+    func = jerryx_arg_transform_native_pointer_optional;
+  }
+  else
+  {
+    func = jerryx_arg_transform_native_pointer;
+  }
+
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = (void *) dest,
+    .extra_info = (uintptr_t) info_p
+  };
+} /* jerryx_arg_native_pointer */
+
+/**
+ * Create a jerryx_arg_t instance for ignored argument.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_ignore (void)
+{
+  return (jerryx_arg_t)
+  {
+    .func = jerryx_arg_transform_ignore
+  };
+} /* jerryx_arg_ignore */
+
+/**
+ * Create a jerryx_arg_t instance with custom transform.
+ *
+ * @return a jerryx_arg_t instance.
+ */
+static inline jerryx_arg_t
+jerryx_arg_custom (void *dest, /**< points to the native argument */
+                   uintptr_t extra_info, /**< the extra infomation of the jerryx_arg_t */
+                   jerryx_arg_transform_func_t func) /**< the custom transform function */
+{
+  return (jerryx_arg_t)
+  {
+    .func = func,
+    .dest = dest,
+    .extra_info = extra_info
+  };
+} /* jerryx_arg_custom */
+
+#endif /* !JERRYX_ARGS_IMPL_H */
diff --git a/tests/unit-ext/CMakeLists.txt b/tests/unit-ext/CMakeLists.txt
new file mode 100644
index 0000000000..53896df62a
--- /dev/null
+++ b/tests/unit-ext/CMakeLists.txt
@@ -0,0 +1,37 @@
+# Copyright JS Foundation and other contributors, http://js.foundation
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+cmake_minimum_required (VERSION 2.8.12)
+project (unit-ext C)
+
+# Unit tests main modules
+file(GLOB SOURCE_UNIT_TEST_EXT_MODULES *.c)
+
+# Unit tests declaration
+add_custom_target(unittests-ext)
+
+foreach(SOURCE_UNIT_TEST_EXT ${SOURCE_UNIT_TEST_EXT_MODULES})
+  get_filename_component(TARGET_NAME ${SOURCE_UNIT_TEST_EXT} NAME_WE)
+  set(TARGET_NAME unit-${TARGET_NAME})
+
+  add_executable(${TARGET_NAME} ${SOURCE_UNIT_TEST_EXT})
+  set_property(TARGET ${TARGET_NAME}
+               PROPERTY LINK_FLAGS "${LINKER_FLAGS_COMMON}")
+
+  link_directories(${CMAKE_BINARY_DIR})
+
+  target_link_libraries(${TARGET_NAME} jerry-ext jerry-core jerry-port-default-minimal)
+
+  add_dependencies(unittests-ext ${TARGET_NAME})
+endforeach()
diff --git a/tests/unit-ext/test-common.h b/tests/unit-ext/test-common.h
new file mode 100644
index 0000000000..539f5bfebc
--- /dev/null
+++ b/tests/unit-ext/test-common.h
@@ -0,0 +1,49 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+#ifndef TEST_COMMON_H
+#define TEST_COMMON_H
+
+#include "jerryscript-port.h"
+
+/*
+ * Conditions' likeliness, unlikeliness.
+ */
+#ifdef __GNUC__
+#define likely(x)       __builtin_expect(!!(x), 1)
+#define unlikely(x)     __builtin_expect(!!(x), 0)
+#else /* !__GNUC__ */
+#define likely(x)       (x)
+#define unlikely(x)     (x)
+#endif /* __GNUC__ */
+
+
+#define TEST_ASSERT(x) \
+  do \
+  { \
+    if (unlikely (!(x))) \
+    { \
+      jerry_port_log (JERRY_LOG_LEVEL_ERROR, \
+                      "TEST: Assertion '%s' failed at %s(%s):%lu.\n", \
+                      #x, \
+                      __FILE__, \
+                      __func__, \
+                      (unsigned long) __LINE__); \
+      jerry_port_fatal (ERR_FAILED_INTERNAL_ASSERTION); \
+    } \
+  } while (0)
+
+
+#endif /* TEST_COMMON_H */
diff --git a/tests/unit-ext/test-ext-args.c b/tests/unit-ext/test-ext-args.c
new file mode 100644
index 0000000000..f2da7dce5e
--- /dev/null
+++ b/tests/unit-ext/test-ext-args.c
@@ -0,0 +1,298 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+/**
+ * Unit test for jerry-ext/args.
+ */
+
+#include "jerryscript.h"
+#include "jerryscript-ext/args.h"
+#include "test-common.h"
+
+#include <string.h>
+
+const char *test_source = (
+                           "var arg1 = true;"
+                           "var arg2 = 10.5;"
+                           "var arg3 = 'abc';"
+                           "var arg4 = function foo() {};"
+                           "test_validator1(arg1, arg2, arg3, arg4);"
+                           "arg1 = new Boolean(true);"
+                           "arg3 = new String('abc');"
+                           "test_validator1(arg1, arg2, arg3);"
+                           "arg2 = new Number(10.5);"
+                           "test_validator1(arg1, arg2, arg3);"
+                           "test_validator1(arg1, 10.5, 'abcdef');"
+                           "var obj_a = new MyObjectA();"
+                           "var obj_b = new MyObjectB();"
+                           "test_validator2.call(obj_a, 5);"
+                           "test_validator2.call(obj_b, 5);"
+                           "test_validator2.call(obj_a, 1);"
+                           );
+
+
+
+static const jerry_object_native_info_t thing_a_info =
+{
+  .free_cb = NULL
+};
+
+static const jerry_object_native_info_t thing_b_info =
+{
+  .free_cb = NULL
+};
+
+typedef struct
+{
+  int x;
+} my_type_a_t;
+
+typedef struct
+{
+  bool x;
+} my_type_b_t;
+
+static my_type_a_t my_thing_a;
+static my_type_b_t my_thing_b;
+
+
+static int validator1_count = 0;
+static int validator2_count = 0;
+
+/**
+ * The handler should have following arguments:
+ *   this: Ignore.
+ *   arg1: Bool.
+ *   arg2: Number. It must be strict primitive number.
+ *   arg3: String.
+ *   arg4: function. It is an optional argument.
+ *
+ */
+static jerry_value_t
+test_validator1_handler (const jerry_value_t func_obj_val __attribute__((unused)), /**< function object */
+                         const jerry_value_t this_val, /**< this value */
+                         const jerry_value_t args_p[], /**< arguments list */
+                         const jerry_length_t args_cnt) /**< arguments length */
+{
+
+  bool arg1;
+  double arg2 = 0.0;
+  char arg3[5];
+  jerry_value_t arg4 = jerry_create_undefined ();
+
+  jerryx_arg_t mapping[] =
+  {
+    /* ignore this */
+    jerryx_arg_ignore (),
+    /* 1st argument should be boolean */
+    jerryx_arg_boolean (&arg1, JERRYX_ARG_COERCE, JERRYX_ARG_REQUIRED),
+    /* 2nd argument should be strict number */
+    jerryx_arg_number (&arg2, JERRYX_ARG_NO_COERCE, JERRYX_ARG_REQUIRED),
+    /* 3th argument should be string */
+    jerryx_arg_string (arg3, 5, JERRYX_ARG_COERCE, JERRYX_ARG_REQUIRED),
+    /* 4th argument should be function, and it is optional */
+    jerryx_arg_function (&arg4, JERRYX_ARG_OPTIONAL)
+  };
+
+  jerry_value_t is_ok = jerryx_arg_transform_all (this_val,
+                                                  args_p,
+                                                  args_cnt,
+                                                  mapping,
+                                                  5);
+
+
+
+  if (validator1_count == 0)
+  {
+    TEST_ASSERT (!jerry_value_has_error_flag (is_ok));
+    TEST_ASSERT (arg1);
+    TEST_ASSERT (arg2 == 10.5);
+    TEST_ASSERT (arg3[0] == 'a' && arg3[1] == 'b'
+                 && arg3[2] == 'c' && arg3[4] == '\0');
+    TEST_ASSERT (jerry_value_is_function (arg4));
+  }
+  else if (validator1_count == 1)
+  {
+    TEST_ASSERT (!jerry_value_has_error_flag (is_ok));
+    TEST_ASSERT (arg1);
+    TEST_ASSERT (arg2 == 10.5);
+    TEST_ASSERT (arg3[0] == 'a' && arg3[1] == 'b'
+                 && arg3[2] == 'c' && arg3[4] == '\0');
+    TEST_ASSERT (jerry_value_is_undefined (arg4));
+  }
+  else
+  {
+    TEST_ASSERT (jerry_value_has_error_flag (is_ok));
+  }
+
+  jerry_release_value (is_ok);
+  jerry_release_value (arg4);
+  validator1_count ++;
+
+  return jerry_create_undefined ();
+} /* test_validator1_handler */
+
+/**
+ * The JS argument should be number, whose value is equal with the extra_info .
+ */
+static jerry_value_t
+my_custom_transform (jerryx_arg_iterator_t *iterator_p)
+{
+  jerry_value_t js_arg = jerryx_arg_iterator_pop (iterator_p);
+  jerry_value_t to_number = jerry_value_to_number (js_arg);
+
+  if (jerry_value_has_error_flag (to_number))
+  {
+    jerry_release_value (to_number);
+
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "It can not be converted to a number.");
+  }
+
+  int expected_num = (int) iterator_p->c_arg_p->extra_info;
+  int get_num = (int) jerry_get_number_value (to_number);
+
+  if (get_num != expected_num)
+  {
+    return jerry_create_error (JERRY_ERROR_TYPE,
+                               (jerry_char_t *) "Number value is not expected.");
+  }
+
+  return jerry_create_undefined ();
+} /* my_custom_transform */
+
+/**
+ * The handler should have following arguments:
+ *   this: with native pointer whose type is bind_a_info.
+ *   arg1: should pass the custom tranform function.
+ */
+static jerry_value_t
+test_validator2_handler (const jerry_value_t func_obj_val __attribute__((unused)), /**< function object */
+                         const jerry_value_t this_val, /**< this value */
+                         const jerry_value_t args_p[], /**< arguments list */
+                         const jerry_length_t args_cnt) /**< arguments length */
+{
+  my_type_a_t *thing_p;
+
+  jerryx_arg_t mapping[] =
+  {
+    /* this should has native pointer, whose type is thing_a_info */
+    jerryx_arg_native_pointer ((void **) &thing_p, &thing_a_info, JERRYX_ARG_REQUIRED),
+    /* custom tranform function */
+    jerryx_arg_custom (NULL, 5, my_custom_transform)
+  };
+
+  jerry_value_t is_ok = jerryx_arg_transform_all (this_val,
+                                                  args_p,
+                                                  args_cnt,
+                                                  mapping,
+                                                  2);
+
+
+
+  if (validator2_count == 0)
+  {
+    TEST_ASSERT (!jerry_value_has_error_flag (is_ok));
+    TEST_ASSERT (thing_p == &my_thing_a);
+    TEST_ASSERT (thing_p->x == 1);
+  }
+  else
+  {
+    TEST_ASSERT (jerry_value_has_error_flag (is_ok));
+  }
+
+  jerry_release_value (is_ok);
+  validator2_count ++;
+
+  return jerry_create_undefined ();
+
+
+} /* test_validator2_handler */
+
+static jerry_value_t
+create_object_a_handler (const jerry_value_t func_obj_val __attribute__((unused)), /**< function object */
+                         const jerry_value_t this_val, /**< this value */
+                         const jerry_value_t args_p[] __attribute__((unused)), /**< arguments list */
+                         const jerry_length_t args_cnt __attribute__((unused))) /**< arguments length */
+{
+  TEST_ASSERT (jerry_value_is_object (this_val));
+
+  my_thing_a.x = 1;
+  jerry_set_object_native_pointer (this_val,
+                                   &my_thing_a,
+                                   &thing_a_info);
+
+  return jerry_create_boolean (true);
+} /* create_object_a_handler */
+
+static jerry_value_t
+create_object_b_handler (const jerry_value_t func_obj_val __attribute__((unused)), /**< function object */
+                         const jerry_value_t this_val, /**< this value */
+                         const jerry_value_t args_p[] __attribute__((unused)), /**< arguments list */
+                         const jerry_length_t args_cnt __attribute__((unused))) /**< arguments length */
+{
+  TEST_ASSERT (jerry_value_is_object (this_val));
+
+  my_thing_b.x = false;
+  jerry_set_object_native_pointer (this_val,
+                                   &my_thing_b,
+                                   &thing_b_info);
+
+  return jerry_create_boolean (true);
+} /* create_object_b_handler */
+
+/**
+ * Register a JavaScript function in the global object.
+ */
+static void
+register_js_function (const char *name_p, /**< name of the function */
+                      jerry_external_handler_t handler_p) /**< function callback */
+{
+  jerry_value_t global_obj_val = jerry_get_global_object ();
+
+  jerry_value_t function_val = jerry_create_external_function (handler_p);
+  jerry_value_t function_name_val = jerry_create_string ((const jerry_char_t *) name_p);
+  jerry_value_t result_val = jerry_set_property (global_obj_val, function_name_val, function_val);
+
+  jerry_release_value (function_name_val);
+  jerry_release_value (function_val);
+  jerry_release_value (global_obj_val);
+
+  jerry_release_value (result_val);
+} /* register_js_function */
+
+int
+main (void)
+{
+  jerry_init (JERRY_INIT_EMPTY);
+
+  register_js_function ("test_validator1", test_validator1_handler);
+  register_js_function ("test_validator2", test_validator2_handler);
+  register_js_function ("MyObjectA", create_object_a_handler);
+  register_js_function ("MyObjectB", create_object_b_handler);
+
+  jerry_value_t parsed_code_val = jerry_parse ((jerry_char_t *) test_source, strlen (test_source), false);
+  TEST_ASSERT (!jerry_value_has_error_flag (parsed_code_val));
+
+  jerry_value_t res = jerry_run (parsed_code_val);
+  TEST_ASSERT (!jerry_value_has_error_flag (res));
+  TEST_ASSERT (validator1_count == 4);
+  TEST_ASSERT (validator2_count == 3);
+
+  jerry_release_value (res);
+  jerry_release_value (parsed_code_val);
+
+  jerry_cleanup ();
+} /* main */
diff --git a/tools/build.py b/tools/build.py
index d6c1af63ce..7ab91d7997 100755
--- a/tools/build.py
+++ b/tools/build.py
@@ -74,6 +74,8 @@ def devhelp(helpstring):
                         help='enable the jerry debugger (%(choices)s; default: %(default)s)')
     parser.add_argument('--jerry-debugger-port', metavar='N', action='store', type=int, default=5001,
                         help='add custom port number (default: %(default)s)')
+    parser.add_argument('--jerry-ext', metavar='X', choices=['ON', 'OFF'], default='ON', type=str.upper,
+                        help='build jerry-ext (default: %(default)s)')
     parser.add_argument('--jerry-libc', metavar='X', choices=['ON', 'OFF'], default='ON', type=str.upper,
                         help='build and use jerry-libc (%(choices)s; default: %(default)s)')
     parser.add_argument('--jerry-libm', metavar='X', choices=['ON', 'OFF'], default='ON', type=str.upper,
@@ -145,6 +147,7 @@ def generate_build_options(arguments):
     build_options.append('-DJERRY_CMDLINE=%s' % arguments.jerry_cmdline)
     build_options.append('-DJERRY_CMDLINE_MINIMAL=%s' % arguments.jerry_cmdline_minimal)
     build_options.append('-DJERRY_PORT_DEFAULT=%s' % arguments.jerry_port_default)
+    build_options.append('-DJERRY_EXT=%s' % arguments.jerry_ext)
     build_options.append('-DJERRY_LIBC=%s' % arguments.jerry_libc)
     build_options.append('-DJERRY_LIBM=%s' % arguments.jerry_libm)
     build_options.append('-DFEATURE_JS_PARSER=%s' % arguments.js_parser)
diff --git a/tools/check-cppcheck.sh b/tools/check-cppcheck.sh
index c6dd1dbc52..6f7cb54269 100755
--- a/tools/check-cppcheck.sh
+++ b/tools/check-cppcheck.sh
@@ -23,12 +23,14 @@ else
 fi
 
 JERRY_CORE_DIRS=`find jerry-core -type d`
+JERRY_EXT_DIRS=`find jerry-ext -type d`
 JERRY_PORT_DIRS=`find jerry-port -type d`
 JERRY_LIBC_DIRS=`find jerry-libc -type d`
 JERRY_LIBM_DIRS=`find jerry-libm -type d`
 
+
 INCLUDE_DIRS=()
-for DIR in $JERRY_CORE_DIRS $JERRY_PORT_DIRS $JERRY_LIBC_DIRS $JERRY_LIBM_DIRS
+for DIR in $JERRY_CORE_DIRS $JERRY_EXT_DIRS $JERRY_PORT_DIRS $JERRY_LIBC_DIRS $JERRY_LIBM_DIRS
 do
  INCLUDE_DIRS=("${INCLUDE_DIRS[@]}" "-I$DIR")
 done
@@ -41,4 +43,4 @@ cppcheck -j$CPPCHECK_JOBS --force \
  --exitcode-suppressions=tools/cppcheck/suppressions-list \
  --suppressions-list=tools/cppcheck/suppressions-list \
  "${INCLUDE_DIRS[@]}" \
- jerry-core jerry-port jerry-libc jerry-libm jerry-main tests/unit-*
+ jerry-core jerry-ext jerry-port jerry-libc jerry-libm jerry-main tests/unit-*
diff --git a/tools/check-license.py b/tools/check-license.py
index 76573d6f72..56d4b3c232 100755
--- a/tools/check-license.py
+++ b/tools/check-license.py
@@ -40,6 +40,7 @@
 INCLUDE_DIRS = [
     'cmake',
     'jerry-core',
+    'jerry-ext',
     'jerry-libc',
     'jerry-libm',
     'jerry-main',
diff --git a/tools/check-vera.sh b/tools/check-vera.sh
index 617bc2eb9a..e837545890 100755
--- a/tools/check-vera.sh
+++ b/tools/check-vera.sh
@@ -15,6 +15,7 @@
 # limitations under the License.
 
 JERRY_CORE_FILES=`find ./jerry-core -name "*.c" -or -name "*.h"`
+JERRY_EXT_FILES=`find ./jerry-ext -name "*.c" -or -name "*.h"`
 JERRY_PORT_FILES=`find ./jerry-port -name "*.c" -or -name "*.h"`
 JERRY_LIBC_FILES=`find ./jerry-libc -name "*.c" -or -name "*.h"`
 JERRY_LIBM_FILES=`find ./jerry-libm -name "*.c" -or -name "*.h"`
@@ -28,4 +29,4 @@ fi
 
 vera++ -r tools/vera++ -p jerry \
  -e --no-duplicate \
- $MANUAL_CHECK_FILES $JERRY_CORE_FILES $JERRY_PORT_FILES $JERRY_LIBC_FILES $JERRY_LIBM_FILES $JERRY_MAIN_FILES $UNIT_TEST_FILES
+ $MANUAL_CHECK_FILES $JERRY_CORE_FILES $JERRY_EXT_FILES $JERRY_PORT_FILES $JERRY_LIBC_FILES $JERRY_LIBM_FILES $JERRY_MAIN_FILES $UNIT_TEST_FILES
diff --git a/tools/cppcheck/suppressions-list b/tools/cppcheck/suppressions-list
index 8f55d6e0c2..673df0e2ad 100644
--- a/tools/cppcheck/suppressions-list
+++ b/tools/cppcheck/suppressions-list
@@ -2,3 +2,4 @@ wrongmathcall:tests/unit-libm/test-libm.inc.h
 variableScope:jerry-libm/*.c
 invalidPointerCast:jerry-libm/*.c
 arithOperationsOnVoidPointer:jerry-libc/*.c
+commaSeparatedReturn:jerry-ext/include/jerryscript-ext/args.impl.h
